package TestBase;

use strict;

use vars qw(@ISA @EXPORT);

use Exporter;
@ISA = qw(Exporter);

@EXPORT = qw(TESTSUFFIX
             TESTSTORED
             TESTDB
             DATASUFFIX

             DELIM

             COURSEDIR

             course_dir
             test_dir

             STOPPED
             USERS
             TESTTYPE

             TEST_CONCEPT
             TEST_ORDINARY

             NUM_ANSWERS
             TESTID

             TEST
             TITLE
             ITEM
             QUESTION
	     IMAGE
	     TEXT
             ANSWER
             CORRECT
	     LOC
             TRUE
             FALSE
             PROLOGUE
             EPILOGUE);

# Base directory for all courses.
use constant COURSEDIR => './courses';

# Suffix for test to upload.
use constant TESTSUFFIX => '.html';

# Dumped test.
use constant TESTSTORED => '.sto';

# Test score database in DB format.
use constant TESTDB => '.db';

# Suffix for score data.
use constant DATASUFFIX => '.data';

# Delimiter for scores
use constant DELIM => ':';

sub course_dir { my ($course) = @_;
  COURSEDIR . '/' . $course
}

sub test_dir { my ($course, $test_name) = @_;
  course_dir($course) . '/' . $test_name
}

# Whether test is stopped.
use constant STOPPED => 'stopped';

use constant USERS => 'users';

# Test type.
use constant TESTTYPE => 'testtype';

use constant TEST_CONCEPT => 'Concept';
use constant TEST_ORDINARY => 'Ordinary';

use constant NUM_ANSWERS => '0num_answers';
use constant NUM_ANSWERS2 => '0num_answers2';

# An almost unique ID to distinguish between tests.
use constant TESTID => 'testid';

# XML test.dtd elements and constants
use constant TEST => 'test';
use constant TITLE => 'title';
use constant ITEM => 'item';
use constant QUESTION => 'question';
use constant IMAGE => 'image';
use constant TEXT => 'text';
use constant ANSWER => 'answer';
use constant CORRECT => 'correct';
use constant LOC => 'loc';
use constant TRUE => 'true';
use constant FALSE => 'false';
use constant PROLOGUE => 'prologue';
use constant EPILOGUE => 'epilogue';

### expat {obj} fields:
# $title;
# $prologue;
# $epilogue;

# $question;
# $answer_text;
# $answer_correct;
# $answer_rect;

# $items;
# $curItem;
# $curQ;
### End fields

# For fatal Web errors.
$ENV{SERVER_ADMIN} = 'pebbles@cs.cmu.edu';

1;

__END__

# Sample nested list.
my $items =
  [
   ['What is the speed limit?',
    ['45', 0],
    ['55', 0],
    ['65', 1],
    ['70', 0]
   ],

   ['When is lunch?',
    ['10:00', 1],
    ['11:00', 0],
    ['12:00', 0],
    ['1:00', 0]
   ]
  ];
